package analisi;


import org.neo4j.graphalgo.shortestpath.FindPath;

import org.neo4j.graphdb.Direction;
import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;
import org.neo4j.graphdb.Transaction;
import org.neo4j.index.IndexHits;
import org.neo4j.index.IndexService;
import org.neo4j.index.lucene.LuceneIndexService;
import org.neo4j.kernel.EmbeddedGraphDatabase;

public class Prova {

	public static void main(String argc[]){


		System.out.println("apro il database");

		GraphDatabaseService graphDb = new EmbeddedGraphDatabase( "neo4j-db/" );

		System.out.println("avvio l'indice");
		IndexService index = new LuceneIndexService( graphDb );
		System.out.println("apro la transazione");
		Transaction tx = graphDb.beginTx();



		IndexHits<Node> lista = index.getNodes("name", "Politecnico di Milano");
		System.out.println("ci sono "+lista.size()+" elementi con tale nome");
		
		for(Node n:lista){
			if (n.hasProperty("idcat")){
				//è una categoria
				System.out.println("ecco la categoria "+n.getProperty("name"));
				System.out.println("appartiene alle categorie:");
				for(Relationship r:n.getRelationships(DynamicRelationshipType.withName( "SUBCATEGORYOF" ), Direction.OUTGOING)){
					System.out.println(" "+r.getEndNode().getProperty("name"));
				}

				System.out.println("e contiene le categorie:");
				for(Relationship r:n.getRelationships(DynamicRelationshipType.withName( "SUBCATEGORYOF" ), Direction.INCOMING)){
					System.out.println(" "+r.getStartNode().getProperty("name"));
				}
				
				System.out.println("questa categoria contiene le pagine:");
				for(Relationship r:n.getRelationships(DynamicRelationshipType.withName( "BELONGSTO" ), Direction.INCOMING)){
					System.out.println(" "+r.getStartNode().getProperty("name"));
				}
				

			}
			else{
				//è una pagina
				System.out.println("ecco la pagina "+n.getProperty("name"));
				System.out.println("appartiene alle categorie:");
				for(Relationship r:n.getRelationships(DynamicRelationshipType.withName( "BELONGSTO" ), Direction.OUTGOING)){
					System.out.println(" "+r.getEndNode().getProperty("name"));
				}

			}

		}


		System.out.println("finito!");
		tx.success();
		tx.finish();

		graphDb.shutdown();

	}
}
