package batch;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Transaction;
import org.neo4j.index.IndexService;
import org.neo4j.index.lucene.LuceneIndexBatchInserter;
import org.neo4j.index.lucene.LuceneIndexBatchInserterImpl;
import org.neo4j.index.lucene.LuceneIndexService;
import org.neo4j.kernel.EmbeddedGraphDatabase;
import org.neo4j.kernel.impl.batchinsert.BatchInserter;
import org.neo4j.kernel.impl.batchinsert.BatchInserterImpl;

public class ReintegraNodiOrfani {



	/*
	 * Leggo l'elenco degli orfani, e per ognuno cerco l'elemento in links.txt (o meglio, nell'indice costruito a partire da links.txt)
	 * Se appartiene a un redirect, vado al prossimo orfano
	 * Se non appartiene a un redirect cerco la categoria e lo lego ad essa
	 * Se non esiste la categoria lo segno in un log di errore
	 * */
	public static void main(String argc[]) throws IOException{



		System.out.println("Apertura files...");
		Lettore orfani=new Lettore("uncategorized.txt");



		//questo if serve a spezzettare il lavoro in più parti, e va usato insieme al file blocca.txt
		if(true){

			System.out.println("apro il database ausiliario");


			//creo l'oggetto per inserire i dati senza transazioni (modalità batch)
			BatchInserter inserter = new BatchInserterImpl( "aux2/", BatchInserterImpl.loadProperties( "neo4j.props" ) );
			//creo il servizio di indicizzazione per i nodi
			LuceneIndexBatchInserter indexService = new LuceneIndexBatchInserterImpl( inserter );



			//		GraphDatabaseService aux = new EmbeddedGraphDatabase( "aux/" );
			//
			//		System.out.println("avvio l'indice ausiliario");
			//		IndexService indexaux = new LuceneIndexService( aux );
			//		System.out.println("apro la transazione ausiliaria");
			//		Transaction txaux = aux.beginTx();


			//memorizzo tutte le coppie articolo->link nel db ausiliario
			System.out.println("Avvio idratazione del database");
			Lettore links=new Lettore("links.txt");
			String rigaLink;
			int auxact=0;
			boolean interrotto=false;
			Map<String,Object> properties = new HashMap<String,Object>();
			Date inizio=new Date();
			while((rigaLink=links.leggi())!=null){
				auxact++;
				//questa riga serve a saltare a una certa riga del file in modo da riprendere il lavoro interrotto
				if(auxact<38335000)continue;

				if(auxact%5000==0)if(new File("blocca.txt").exists()){interrotto = true;break;}
				if(auxact%5000==0){
					System.out.println("idrato db ausiliario: "+auxact+" - "+new Date().toString());
					Date arrivo=new Date((((new Date().getTime()-inizio.getTime())/(auxact/1000))*40000)+inizio.getTime());
					System.out.println("    fine prevista per "+arrivo.toString());
				}

				properties.clear();


				String[] parti = rigaLink.split(">");
				parti[1]=parti[1].replace("_", " ");
				parti[1]=parti[1].replace("&amp;", "&");
				parti[1]=parti[1].replace("[^-a-zA-Z 0-9_&!?^=$()\\[\\]{}\\\\/]", "");

				properties.put("from", rigaLink.split(">")[0]);
				properties.put("to", parti[1]);
				long node = inserter.createNode( properties );



				indexService.index( node, "from",rigaLink.split(">")[0]);   
				indexService.index( node, "to",rigaLink.split(">")[1]);   
				//			
				//			Node n=aux.createNode();
				//			n.setProperty("from", appartenenza.split(">")[0]);
				//			n.setProperty("to", appartenenza.split(">")[1]);
				//			indexaux.index(n, "from",appartenenza.split(">")[0]);
				//			indexaux.index(n, "to",appartenenza.split(">")[1]);
			}

			links.chiudi();
			if(interrotto){
				System.out.println("programma interrotto manualmente");
				//			txaux.failure();
				//			txaux.finish();
				//			aux.shutdown();
				indexService.optimize();
				indexService.shutdown();
				inserter.shutdown();
				System.exit(1);
			}
			System.out.println("ho memorizzato e indicizzato tutte le informazioni from->to");
			indexService.optimize();
			indexService.shutdown();
			inserter.shutdown();
		}

		System.out.println("riapro il database, non più in modalità batch");

		GraphDatabaseService aux = new EmbeddedGraphDatabase( "aux2/" );

		System.out.println("avvio l'indice ausiliario");
		IndexService indexaux = new LuceneIndexService( aux );
		System.out.println("apro la transazione ausiliaria");
		Transaction txaux = aux.beginTx();




		System.out.println("apro il database");

		GraphDatabaseService graphDb = new EmbeddedGraphDatabase( "wp_semantico/" );

		System.out.println("avvio l'indice");
		IndexService index = new LuceneIndexService( graphDb );
		System.out.println("apro la transazione");
		Transaction tx = graphDb.beginTx();


		int azioni=0;
		String orfana;

		Scrittore err=new Scrittore("Errori rigenerazione.txt");
		while((orfana=orfani.leggi())!=null){
			azioni++;
			if(new File("blocca.txt").exists())break;
			if(azioni%100==0){
				System.out.println("azione "+azioni);
				tx.success();
				tx.finish();
				tx=graphDb.beginTx();
				txaux.success();
				txaux.finish();
				txaux=aux.beginTx();

			}
			Node questaPagina=null;
			//prendo il codice della pagina, se c'è
			String idpag=null;
			for(Node n:index.getNodes("name", orfana)){
				if (n.hasProperty("idpag")){
					idpag=n.getProperty("idpag").toString();
					questaPagina=n;
				}
			}
			if(idpag==null){
				//non c'è nessuna pagina con quel nome, segnalo e la salto
				err.scrivi("Errore, alla riga "+azioni+" non trovo nessuna pagina di nome "+orfana);
				continue;
			}


			boolean interna=false;
			boolean trovate=false;
			String appartenenza;
			for(Node naux:indexaux.getNodes("from", idpag)){
				appartenenza=naux.getProperty("from")+">"+naux.getProperty("to");
				if (appartenenza.startsWith(idpag+">")){
					//è un redirect?
					if (appartenenza.indexOf("edirect")!=-1){
						//è un redirect, salto la pagina orfana
						System.out.println("redirect: "+appartenenza);
						naux.delete();
						interna=true;
						break;
					}
					//non è un redirect


					//è una disambigua?
					if (appartenenza.indexOf("ambiguation")!=-1){
						//è una disambigua
						System.out.println("disambigua: "+appartenenza);
						naux.delete();
						interna=true;
						break;
					}
					//non è una disambigua

					//recupero la categoria d'appartenenza
					String categoria=appartenenza.split(">")[1];
					boolean trovatacat=false;
					for(Node n:index.getNodes("name", categoria)){
						if (n.hasProperty("idcat")){
							trovatacat=true;
							questaPagina.createRelationshipTo(n, DynamicRelationshipType.withName( "BELONGSTO" ));
							System.out.println("CATEGORIZZATA: "+orfana+" IN "+categoria);
							err.scrivi("CATEGORIZZATA: "+orfana+" IN "+categoria);
							continue;
						}
					}
					if (!trovatacat){
						err.scrivi("Errore, non esiste "+categoria+" ma "+orfana+" le appartiene nella riga "+appartenenza);
						System.out.println("ERRORE, non esiste "+categoria+" ma "+orfana+" le appartiene nella riga "+appartenenza);
					}
				}
			}

			if (interna)continue;

		}
		System.out.println("fatto, chiudo...");
		err.chiudi();
		orfani.chiudi();

		tx.success();
		tx.finish();
		graphDb.shutdown();

		System.exit(1);

	}

}
