package batch;

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;



public class Scrittore {


	public static void main(String argc[]) throws IOException{
		Lettore l=new Lettore("links.txt");
		Scrittore s=new Scrittore("links_t.txt");
		for (int a=0;a<1000;a++)s.scrivi(l.leggi());
		s.chiudi();
		l.chiudi();
	}

	BufferedWriter out;
	boolean utilizzato=false;
	private String risorsa;

	public Scrittore(String percorso) throws IOException{
		this.risorsa=percorso;
		FileWriter fstream = new FileWriter(percorso);
		out = new BufferedWriter(fstream);
	}

	public Scrittore(Lettore l) throws IOException{
		this.risorsa=l.toString();
		FileWriter fstream = new FileWriter(l.toString());
		out = new BufferedWriter(fstream);

	}
	/**
	 * Scrive la stringa in una nuova riga, a parte la prima nel file 
	 * */
	public void scrivi(String riga) throws IOException{
		if(utilizzato)
			out.write("\n"+riga);
		else
			out.write(riga);
		utilizzato=true;
	}

	public void chiudi() throws IOException{
		out.close();
	}

	public BufferedWriter getWriter() {
		return out;
	}


	public String toString(){
		return this.risorsa;
	}

	/**
	 * Copia il contenuto del file indicato dal lettore nel file correntemente aperto
	 * @throws IOException 
	 * */
	public void copiaFile(Lettore l) throws IOException{

		FileInputStream fis  = new FileInputStream(l.toString());
		FileOutputStream fos = new FileOutputStream(this.risorsa);
		try {
			byte[] buf = new byte[1024];
			int i = 0;
			while ((i = fis.read(buf)) != -1) {
				fos.write(buf, 0, i);
			}
		} 
		catch (IOException e) {
			throw e;
		}
		finally {
			if (fis != null) fis.close();
			if (fos != null) fos.close();
		}
	}

}
