package batch;


import java.io.IOException;
import java.util.Date;

import org.neo4j.graphdb.Direction;
import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;
import org.neo4j.graphdb.Transaction;
import org.neo4j.kernel.EmbeddedGraphDatabase;

import batch.Scrittore;

public class TrasferimentoInPajek {
	//salvo il grafo nel formato di Pajek
	//che puÃ² essere analizzato da igraph
	//http://airwiki.elet.polimi.it/mediawiki/index.php/Social_Network_Analysis_With_Igraph_Package_Using_R
	public static void main(String argc[]) throws IOException{
		System.out.println("apro il database");

		GraphDatabaseService graphDb = new EmbeddedGraphDatabase( "wp_semantico/" );

		//System.out.println("avvio l'indice");
		//IndexService index = new LuceneIndexService( graphDb );
		System.out.println("apro la transazione");
		Transaction tx = graphDb.beginTx();
		System.out.println("ottengo la lista di tutti i nodi...");

		Iterable<Node> tutti = graphDb.getAllNodes();


		System.out.println("ottenuta, li conto...");
		int contatore=0;
		for(Node n:tutti) {contatore++;if(contatore%10000==0) System.out.println("contati finora: "+contatore);}
		System.out.println("contati, sono "+contatore);


		//apro il file per la scrittura

		Scrittore pf=new Scrittore("rete.NET");
		Scrittore log=new Scrittore("trasferimento_in_Pajek.log");
		log.scrivi("Avvio traduzione: "+new Date().toString());
		tutti = graphDb.getAllNodes();
		System.gc();
		pf.scrivi("*Vertices "+contatore);
		int idpajek=0;
		for(Node n:tutti){
			
			idpajek++;
			n.setProperty("idpajek", idpajek);
			if (idpajek%1000==0){
				//ogni 1000 risultati registro e riapro la transazione
				tx.success();
				tx.finish();
				System.out.println("salvati "+idpajek+" nodi");
				tx = graphDb.beginTx();
			}

//			se Ã¨ una pagina memorizzo idpag, altrimenti idcat
			if(!n.hasProperty("name")){
				System.out.println("nodo senza nome, ma con proprietÃ : "+n.getPropertyKeys());
				log.scrivi("nodo senza nome, ha proprietÃ : "+n.getPropertyKeys());
//				non faccio avanzare l'indice
				idpajek--;
				continue;
			}

			if(n.hasProperty("idpag"))
				pf.scrivi(idpajek+" "+n.getProperty("idpag")+" \""+n.getProperty("name")+"\"");
			else
				pf.scrivi(idpajek+" "+n.getProperty("idcat")+" \""+n.getProperty("name")+"\"");

		}

		System.out.println("ho scritto tutti i vertici, ora gli archi");
		pf.scrivi("*Arcs");
		tutti = graphDb.getAllNodes();
		System.gc();
		tx.success();
		tx.finish();
		tx = graphDb.beginTx();

		for(Node n:tutti){
			if (!n.hasProperty("name")){
				System.out.println("nodo anonimo: "+n.getPropertyKeys());
				log.scrivi("nodo anonimo, ha proprietÃ : "+n.getPropertyKeys());
				continue;
			}
			if (!n.hasProperty("idpajek")){
				System.out.println("nodo senza ID pajek: "+n.getPropertyKeys());
				log.scrivi("nodo senza ID pajek, ha proprietÃ : "+n.getPropertyKeys());
				continue;
			}
			System.out.println("scrivo le relazioni per "+n.getProperty("name"));
			for(Relationship r:n.getRelationships(Direction.OUTGOING)){
				pf.scrivi(
						n.getProperty("idpajek")
						+" "
						+r.getOtherNode(n).getProperty("idpajek")
						+" "
						//non previsto nel formato ? +"\""+r.getType().name()+"\""
				);
			}
		}
		pf.chiudi();

		log.scrivi("Finito! tempo: "+new Date().toString());
		log.chiudi();





		System.out.println("finito!");
		tx.success();
		tx.finish();

		graphDb.shutdown();
	}
}


