package progetto;

import java.io.File;
import java.io.IOException;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Map.Entry;

import org.neo4j.graphalgo.shortestpath.Dijkstra;
import org.neo4j.graphalgo.shortestpath.SingleSourceSingleSinkShortestPath;
import org.neo4j.graphalgo.shortestpath.std.DoubleAdder;
import org.neo4j.graphalgo.shortestpath.std.DoubleComparator;
import org.neo4j.graphalgo.shortestpath.std.DoubleEvaluator;
import org.neo4j.graphdb.Direction;
import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;
import org.neo4j.graphdb.Transaction;
import org.neo4j.index.IndexService;
import org.neo4j.index.lucene.LuceneIndexService;
import org.neo4j.kernel.EmbeddedGraphDatabase;

import distanze.Misuratore;

import utilities.Lettore;
import utilities.Scrittore;
import utilities.User;
import wrapper.GraphWrapper;

/**
 * Hello world!
 *
 */
public class AssegnaAMacrocategorie 
{
	public static void main( String[] args ) throws IOException
	{


		GraphWrapper g=new GraphWrapper("wp_semantico");

		HashSet<String> arrivi=new HashSet<String>();

		//		arrivi.add("Agriculture");
		//		arrivi.add("Applied sciences");
		//		arrivi.add("Arts");
		//		arrivi.add("Belief");
		//		arrivi.add("Business");
		//		arrivi.add("Computing");
		//		arrivi.add("Culture");
		//		arrivi.add("Education");
		//		arrivi.add("Environment");
		//		arrivi.add("Geography");
		//		arrivi.add("Health");
		//		arrivi.add("History");
		//
		//		arrivi.add("Humanities");
		//		arrivi.add("Language");
		//		arrivi.add("Law");
		//		arrivi.add("Life");
		//		arrivi.add("Mathematics");
		//		arrivi.add("Nature");
		//		arrivi.add("People");
		//		arrivi.add("Politics");
		//		arrivi.add("Science");
		//
		//		arrivi.add("Society");
		//		arrivi.add("Technology");

		
//		g.categorizzaIn(g.getCategoria("Chronology"),g.getCategoria("History"));
//		g.categorizzaIn(g.getCategoria("Natural sciences"),g.getCategoria("Science"));
//		g.elimina(g.getCategoria("Nature and environment"));
//		g.elimina(g.getCategoria("Politics and society"));
//		g.elimina(g.getCategoria("Culture and the arts"));
//		
//		
//		Node n=g.createNode();
//
//		n.setProperty("name", "Geography and places");
//		n.setProperty("idcat", "400000004");		
//
//		g.indicizza(n, "name", "Geography and places");
//		g.indicizza(n, "idcat", "400000004");
//
//		g.categorizzaIn(g.getCategoria("Geography"),n);
//		g.categorizzaIn(g.getCategoria("Places"),n);
//		
//		
//		n=g.createNode();
//
//		n.setProperty("name", "History and events");
//		n.setProperty("idcat", "400000005");		
//
//		g.indicizza(n, "name", "History and events");
//		g.indicizza(n, "idcat", "400000005");
//
//		g.categorizzaIn(g.getCategoria("History"),n);
//		g.categorizzaIn(g.getCategoria("Events"),n);
//		
//		
//		g.commit();
		
		arrivi.add("Agriculture");
		
		arrivi.add("Culture");
		arrivi.add("Arts");
		
		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");
	
		arrivi.add("Politics");
		arrivi.add("Society");
		
		arrivi.add("Philosophy");
		
		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");


		Node partenza = null;
		//String nome=User.chiediStringa("pagina di partenza");

		Scrittore uncat=new Scrittore("pagine_inclassificabili.txt");
		Scrittore onecat=new Scrittore("pagine_classificate.txt");
		Scrittore mulcat=new Scrittore("pagine_ambigue.txt");
		Scrittore err=new Scrittore("errori.txt");

		int azioni=0;

		boolean interrotto=false;

		int articoliElaborati=0;
		Misuratore m=new Misuratore(arrivi,g);

		for(Node np:g.getAllNodes()){

			azioni++;
			if (azioni%100==0){
				g.commit();
				System.out.println("nodo "+azioni);
			}
			if(new File("blocca.txt").exists()){interrotto = true;break;}
			if(np.hasProperty("idcat")) continue;


			if (!np.hasProperty("name"))continue;
			String nome=np.getProperty("name").toString();
			System.out.println(azioni+" itero su "+nome);
			if (!np.hasProperty("idpag"))continue;


			System.out.println(azioni+" analizzo "+nome);

			//è un nodo senza appartenenze? Lo salto
			if(!g.getCategorieAppartenenza(np).iterator().hasNext()) continue;

			//			//è una disambigua? Se sì la salto
			//			//TODO non dovrebbero esserci, sono state eliminate in precedenza
			//			if(g.getCategorieAppartenenza(np).iterator().next().getProperty("name").toString().contains("isambiguation")){
			//				continue;				
			//			}


			HashSet<String> appartenenze=new HashSet<String>();
			Double distanzaMin=Double.MAX_VALUE;
			articoliElaborati++;
			System.out.println("   ELABORATI: "+articoliElaborati);
			partenza=np;

			//è un nodo orfano? lo elimino e lo salto

			if(!np.getRelationships().iterator().hasNext()){
				System.out.println("ELIMINO l'orfano "+np.getProperty("name"));
				err.scrivi("ELIMINO l'orfano "+np.getProperty("name"));
				g.elimina(np);
				continue;
			}



			if(g.getCategorieAppartenenza(partenza).size()==0) err.scrivi("Errore, la pagina "+nome+" non è categorizzata");

			//			for(Node ca:g.getCategorieAppartenenza(partenza)){
			//				System.out.println();
			//				for(String prop:ca.getPropertyKeys()){
			//					System.out.println(prop+":"+ca.getProperty(prop));
			//				}
			//			}


			for(Entry<String, Double> prc:m.getDistanze(partenza).entrySet()){
				System.out.println("arrivo a "+prc.getKey()+" in "+prc.getValue()+" passi");
				//tre casi:
				//la lunghezza è maggiore del massimo, lo salto
				if(prc.getValue()>distanzaMin) continue;
				//la lunghezza è uguale, aggiungo l'arrivo al Set
				if(prc.getValue().compareTo(distanzaMin)==0)
					appartenenze.add(prc.getKey());
				//la lunghezza è minore, resetto il set e la abbasso
				if(prc.getValue()<distanzaMin){
					appartenenze.clear();
					appartenenze.add(prc.getKey());
					distanzaMin=prc.getValue();
				}
			}

			//ora il set appartenenze contiene l'elenco delle macrocategorie più vicine
			//ora ho il set delle appartenenze.
			//è vuoto?
			if(appartenenze.size()==0){
				System.out.println("non categorizzato:"+np.getProperty("idpag").toString()+">"+nome);
				uncat.scrivi(np.getProperty("idpag").toString()+">"+nome);
			}

			//ha un solo elemento ?
			if(appartenenze.size()==1){
				System.out.println("categorizzo "+np.getProperty("idpag").toString()+">"+nome+">"+appartenenze.iterator().next());
				onecat.scrivi(np.getProperty("idpag").toString()+">"+nome+">"+appartenenze.iterator().next());
			}

			//ha più elementi ?
			if(appartenenze.size()>1){
				String elementi="";
				for(String el:appartenenze)elementi+=el+"|";
				System.out.println("categorie multiple:"+np.getProperty("idpag").toString()+">"+nome+">"+elementi);
				mulcat.scrivi(np.getProperty("idpag").toString()+">"+nome+">"+elementi);
			}

		}

		if (interrotto) System.out.println("programma interrotto manualmente");
		err.chiudi();
		uncat.chiudi();
		mulcat.chiudi();
		onecat.chiudi();
		g.termina();

	}
}

