package progetto;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.HashSet;
import java.util.List;

import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;

import distanze.Misuratore;

import utilities.Lettore;
import utilities.Scrittore;
import utilities.User;
import wrapper.GraphWrapper;

public class AssegnaDistanzeACategorie {

	public static void main(String argc[]) throws IOException{


		GraphWrapper g=new GraphWrapper("wp_semantico");


		HashSet<String> arrivi=new HashSet<String>();
//		
//		g.categorizzaIn(g.getCategoria("Natural sciences"),g.getCategoria("Science"));
//		g.elimina(g.getCategoria("Nature and environment"));
//		g.elimina(g.getCategoria("Politics and society"));
//		g.elimina(g.getCategoria("Culture and the arts"));
//		
//		
//		Node nuovo=g.createNode();
//
//		nuovo.setProperty("name", "Geography and places");
//		nuovo.setProperty("idcat", "400000004");		
//
//		g.indicizza(nuovo, "name", "Geography and places");
//		g.indicizza(nuovo, "idcat", "400000004");
//
//		g.categorizzaIn(g.getCategoria("Geography"),nuovo);
//		g.categorizzaIn(g.getCategoria("Places"),nuovo);
//		
//		
//		
//		nuovo=g.createNode();
//
//		nuovo.setProperty("name", "History and events");
//		nuovo.setProperty("idcat", "400000005");		
//
//		g.indicizza(nuovo, "name", "History and events");
//		g.indicizza(nuovo, "idcat", "400000005");
//
//		g.categorizzaIn(g.getCategoria("History"),nuovo);
//		g.categorizzaIn(g.getCategoria("Events"),nuovo);
		
//		Node nuovo=g.getCategoria("History");
//		g.categorizzaIn(g.getCategoria("Millennia"),nuovo);
//		g.categorizzaIn(g.getCategoria("Centuries"),nuovo);
//		g.categorizzaIn(g.getCategoria("Decades"),nuovo);
//		g.categorizzaIn(g.getCategoria("Years"),nuovo);
//		g.categorizzaIn(g.getCategoria("Chronicles"),nuovo);
//		g.categorizzaIn(g.getCategoria("Dating methods"),nuovo);
//		g.categorizzaIn(g.getCategoria("Timelines"),nuovo);
//		g.categorizzaIn(g.getCategoria("Hijri dates"),nuovo);
		
		
		
		g.commit();
		
		arrivi.add("Agriculture");
		
		arrivi.add("Culture");
		arrivi.add("Arts");
		
		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");
	
		arrivi.add("Politics");
		arrivi.add("Society");
		
		arrivi.add("Philosophy");
		
		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");




		Scrittore assegnamento=new Scrittore("assegnazione_categorie.txt");
		boolean interrotto=false;

		for(String macrocat:arrivi){

			System.out.println("inizio analisi distanze da "+macrocat);
			assegnamento.scrivi(new Date().toString()+" assegnamento "+macrocat);
			Node partenza=g.getCategoria(macrocat);
			partenza.setProperty("FROM"+macrocat, 0);
			HashSet<Node> attuali=new HashSet<Node>(150000);
			//Languages va considerato come nodo di partenza insieme a Language
			if(macrocat.equals("Language"))
				attuali.add(g.getCategoria("Languages"));
			attuali.add(partenza);
			int costo=0;


			if(macrocat.equals("Technology and applied sciences"))costo--;
			if(macrocat.equals("Geography and places"))costo--;
			if(macrocat.equals("History and events"))costo--;

			int azioni=0;

			while(true){
				if(new File("blocca.txt").exists()){interrotto = true;break;}
				costo++;
				assegnamento.scrivi("   "+new Date().toString()+" livello "+costo+" ne esamino "+attuali.size());
				HashSet<Node> nuovi=new HashSet<Node>(150000);
				//metto in nuovi tutti i nodi in relazione con quelli attuali
				int recuperati=0;
				for(Node p:attuali){
					recuperati++;
					System.out.println("["+recuperati+"/"+attuali.size()+"] ("+costo+") recupero i nodi collegati a uno di quelli già analizzati e privi di proprietà FROM"+macrocat);
					//i nuovi nodi sono quelli direttamente raggiungibili dagli attuali
					for(Relationship r:p.getRelationships(DynamicRelationshipType.withName( "SUBCATEGORYOF" ))){
						if (!r.getOtherNode(p).hasProperty("FROM"+macrocat))nuovi.add(r.getOtherNode(p));
					}
				}

				System.out.println("elimino dalla lista di "+nuovi.size()+" i "+attuali.size()+" nodi già analizzati");
				//tra i nuovi ce ne sono di già analizzati, li elimino

				nuovi.removeAll(attuali);

				if(nuovi.size()==0) break;

				//ce ne sono di nuovi, gli assegno il costo
				int assegnati=0;
				for(Node n:nuovi){
					assegnati++;
					n.setProperty("FROM"+macrocat, costo);
					azioni++;
					System.out.println("["+assegnati+"/"+nuovi.size()+"] il nodo "+n.getProperty("name")+" dista "+costo+" da "+macrocat);
					if (azioni%1000==0)g.commit();
				}
				System.out.println("Ho "+nuovi.size()+" categorie da analizzare ora");
				//i nuovi nodi diventano quelli vecchi
				attuali.clear();
				attuali.addAll(nuovi);
			}
			if (interrotto) System.out.println("programma interrotto manualmente");
			g.commit();
		}
		if (interrotto) System.out.println("programma interrotto manualmente");
		assegnamento.chiudi();

		g.termina();
	}
}
