package progetto;

import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import org.neo4j.graphdb.Node;

import utilities.Lettore;
import utilities.Scrittore;
import wrapper.GraphWrapper;

public class ElencaCategorieOrfane {
	//dato l'elenco delle pagine inclassificabili, genera l'elenco delle categorie mancanti
	public static void main(String[] args) throws IOException {
		GraphWrapper g=new GraphWrapper("wp_semantico");
		Lettore l=new Lettore("pagine_inclassificabili.txt");
		String letta;
		Set<Node>orfane=new HashSet<Node>();
		while((letta=l.leggi())!=null){
			System.out.println(letta);
			Node p=g.getPagina(letta.split(">")[1]);
			if (p==null)continue;
			for(Node cat:g.getCategorieAppartenenza(p)){
				registra(cat,g,orfane);
			}
		}
		
		Scrittore s=new Scrittore("orfane.txt");
		for(Node n:orfane){
			if(!n.hasProperty("idcat")){
				n.setProperty("idcat", n.getProperty("idpag"));
				n.removeProperty("idpag");
				g.commit();
			}
			s.scrivi(n.getProperty("idcat")+">"+n.getProperty("name"));
		}
		s.chiudi();
		g.termina();
		l.chiudi();
	}
	
	public static void registra(Node n,GraphWrapper g,Set<Node> set){
		if (set.contains(n)) return;
		set.add(n);
		System.out.print(" "+n.getProperty("name"));
		for(Node uc:g.getCategorieAppartenenza(n)) registra(uc,g,set);
	}
}
