package progetto;

import java.io.File;
import java.io.IOException;

import org.neo4j.graphdb.Direction;
import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.Node;

import utilities.Scrittore;
import wrapper.GraphWrapper;

public class EstraiOrfani {

	public static void main(String argc[]) throws IOException{

		GraphWrapper g=new GraphWrapper("wp_semantico");
		Scrittore ucat=new Scrittore("categorie_orfane.txt");
		Scrittore upag=new Scrittore("pagine_orfane.txt");
		int conta=0;
		boolean interrotto=false;
		for(Node n:g.getAllNodes()){
			conta++;
			if(conta%5000==0){
				if(new File("blocca.txt").exists()){interrotto = true;break;}
				System.out.println("lettura "+conta);
			}
			//determino se è una categoria o una pagina
			if(n.hasProperty("idpag")){
				if (!n.getRelationships(DynamicRelationshipType.withName( "BELONGSTO" ),Direction.OUTGOING).iterator().hasNext()){
					System.out.println("la pagina "+n.getProperty("name")+" non appartiene a nessuna categoria!");
					upag.scrivi(n.getProperty("idpag")+">"+n.getProperty("name"));
				}
			}

			if(n.hasProperty("idcat")){
				if (!n.getRelationships(DynamicRelationshipType.withName( "SUBCATEGORYOF" ),Direction.OUTGOING).iterator().hasNext()){
					System.out.println("la categoria "+n.getProperty("name")+" non appartiene a nessuna categoria!");
					ucat.scrivi(n.getProperty("idcat")+">"+n.getProperty("name"));
				}
			}

		}
		
		if(interrotto) System.out.println("programma interrotot manualmente");
		g.termina();
		ucat.chiudi();
		upag.chiudi();



	}
}
