package progetto;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;

import org.neo4j.graphdb.Node;

import utilities.Scrittore;
import wrapper.GraphWrapper;

public class GeneraStatisticheFrequenze {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws IOException, InterruptedException {
		//conta le categorie con un certo valore FROMx
		//per permettere la ricostruzione della curva 
		//di distribuzione di fequenza delle distanze

		//Thread.sleep(1000*60*9);


		HashSet<String> arrivi=new HashSet<String>();
		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");

		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");

		arrivi.add("Politics");
		arrivi.add("Society");

		arrivi.add("Philosophy");

		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");

		GraphWrapper g=new GraphWrapper("wp_semantico");
		int azioni=0;
		HashMap<String,Integer> distribuzione=new HashMap<String,Integer>();

		for(Node n:g.getAllNodes()){
			azioni++;
			if (azioni%100==0){
				g.commit();
				System.out.println("azione "+azioni);
				if(azioni%1000==0)
					System.out.println(distribuzione);
			}
			if(azioni>800000) break;
			if(!n.hasProperty("idcat")) continue;
			
			for(String prop:n.getPropertyKeys()){
				if(!prop.startsWith("FROM"))continue;
				double distanza=Double.parseDouble(n.getProperty(prop).toString());

				String aggiunta=prop.substring(4)+":"+distanza;

				if(distribuzione.containsKey(aggiunta))
					distribuzione.put(aggiunta, distribuzione.get(aggiunta)+1);
				else
					distribuzione.put(aggiunta, 1);

			}

		}
		Scrittore s=new Scrittore("frequenze_distanze_costi_NOarticoli.txt");
		String riga="";
		for(String arrivo:arrivi){
			riga+=arrivo+":";
		}
		s.scrivi(riga);

		for(int d=0;d<25;d++){
			riga="";
			for(String arrivo:arrivi){
				riga+=distribuzione.get(arrivo+":"+(double)d)+":";
			}
			s.scrivi(riga);
		}
		
		s.chiudi();
		g.termina();
	}

}
