package progetto;

import java.util.HashSet;
import java.util.List;

import org.neo4j.graphdb.Node;

import utilities.Scrittore;
import utilities.User;
import wrapper.GraphWrapper;
import distanze.Misuratore;

public class MostraPercorsoMinimo {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		GraphWrapper g=new GraphWrapper("wp_semantico");

		HashSet<String> arrivi=new HashSet<String>();
		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");

		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");

		arrivi.add("Politics");
		arrivi.add("Society");

		arrivi.add("Philosophy");

		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");



		Node partenza = null;
		String nome=User.chiediStringa("categoria o pagina di partenza");
		partenza=g.getPagina(nome);
		System.out.println("Ricerco "+nome+"...");
		if(partenza==null) g.getCategoria(nome);
		if (g.getPagina(nome)!=null && g.getCategoria(nome)!=null){
			if(User.scegliOpzione("categoria;pagina","Nome ambiguo:categoria o pagina?").equals("pagina"))
				partenza=g.getPagina(nome);
			else
				partenza=g.getCategoria(nome);
		}
		
		if(partenza==null){
			System.out.println("Categoria o pagina inesistente, chiudo");
			g.termina();
			System.exit(0);
		}
		System.out.println("Appartiene alle categorie:");

		for(Node cat:g.getCategorieAppartenenza(partenza)){
			System.out.println("  "+cat.getProperty("name","NESSUN NOME!")+cat.getPropertyKeys());
		}

		Misuratore m=new Misuratore(arrivi,g);

		System.out.println("Avvio calcolo dei percorsi...");
		for(List<Node> prc:
			m.getPercorsi(partenza)){
			for(Node n:prc){
				System.out.print(" -> "+n.getProperty("name"));
			}
			System.out.println();
		}
		g.termina();
	}

}
