package progetto;

import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;

import utilities.Lettore;
import utilities.Scrittore;
import utilities.User;

public class QuizCorrettezzaAssegnamento {
	public static void main(String argc[]) throws IOException{
		//seleziono una riga dal file delle classificazioni e chiedo all'utente dove la classificherebbe
		int scelta;
		HashSet<String> arrivi=new HashSet<String>();

		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");

		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");

		arrivi.add("Politics");
		arrivi.add("Society");

		arrivi.add("Philosophy");

		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");


		//opzione per saltare la domanda
		arrivi.add("SALTA");

		String opzioni=arrivi.toString();
		opzioni=opzioni.replaceAll(", ", ";");
		opzioni=opzioni.replace("[", "");
		opzioni=opzioni.replace("]", "");


		int assegnati=0;
		Scrittore q=new Scrittore("quiz_flux_quote.txt");
		Lettore c=new Lettore("pagine_classificate_quote_flow.txt");
		int conteggio=0;
		while(c.leggi()!=null) conteggio++;
		c.chiudi();
		System.out.println("Ci sono "+conteggio+" assegnamenti");

		while(true){
			try{

				Lettore l=new Lettore("pagine_inclassificabili_quote_flow.txt");
				scelta=(int)((float)Math.random()*(float)conteggio);
				for(int x=0;x<scelta;x++)l.leggi();
				String domanda=l.leggi();
				String risposta=User.chiediStringa(domanda.split(">")[1]);
				if (risposta.equals("SALTA")) continue;
				if (risposta.equals("")) continue;

				if (risposta.equals("END")) break;
				assegnati++;
				System.out.println(assegnati+" assegnati");
				//genero le hashmap degli assegnamenti fatti dall'utente e dal programma
				HashMap<String,Double> umano=new HashMap<String,Double>();
				HashMap<String,Double> prog=new HashMap<String,Double>();

				for(String ass:risposta.split(";")){
					if(ass.toLowerCase().startsWith("geo")) ass="Geography and places"+":"+ass.split(":")[1];
					if(ass.toLowerCase().startsWith("his")) ass="History and events"+":"+ass.split(":")[1];
					if(ass.toLowerCase().startsWith("tec")) ass="Technology and applied sciences"+":"+ass.split(":")[1];

					umano.put(ass.split(":")[0].toLowerCase(), Double.parseDouble(ass.split(":")[1].replace(',', '.')));
				}
				for(String ass:domanda.split(">")[2].split(";")){
					prog.put(ass.split(":")[0].toLowerCase(), Double.parseDouble(ass.split(":")[1].replace(',', '.')));
				}
				double correlazione=0;
				for(String key:umano.keySet()){
					if (prog.containsKey(key)){
						correlazione+=umano.get(key)*prog.get(key);
						System.out.println("Corrispondenza di "+key+" correlazione a "+correlazione);
					}
				}
				double den1=0,den2=0;
				for(Double v:umano.values()) den1+=v*v;
				for(Double v:prog.values()) den2+=v*v;
				correlazione=correlazione/(Math.sqrt(den1)*Math.sqrt(den2));

				String esito=domanda+">>"+risposta+"#"+domanda.split(">")[1]+"#"+correlazione;
				q.scrivi(esito);
				System.out.println(esito);
			}
			catch(Exception e){
				e.printStackTrace();
			}

		}
		q.chiudi();

	}
}
