package progetto;

import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.Node;

import utilities.Lettore;
import wrapper.GraphWrapper;

public class RiassegnaACategorie {
	//questo programma riassegna le categorie il cui nome e seriale (idcat) sono elencati in un file
	//recuperandoli da links.txt
	//1  leggi 5000 categorie dal file
	//itera su links.txt, se le trovi prova a riassegnare
	//fanne altri 5000
	//dato l'elenco delle pagine inclassificabili, genera l'elenco delle categorie mancanti
	public static void main(String[] args) throws IOException {
		GraphWrapper g=new GraphWrapper("wp_semantico");
		Lettore l=new Lettore("pagine_inclassificabili.txt");
		String letta;
		Set<String>idcats=new HashSet<String>();
		int letti=0;
		while((letta=l.leggi())!=null){
			idcats.add(letta.split(">")[0]);
			letti++;
			if (letti>5000){
				Lettore lnk=new Lettore("links.txt");
				String link;
				while((link=lnk.leggi())!=null){
					if(idcats.contains(link.split(">")[0])){
						System.out.println(link);
						//TODO itero su links.txt
						Node partenza=null;
						for(Node n:g.getNodes("idcat", link.split(">")[0]))
							if(n.hasProperty("idcat")) partenza=n;
						if(partenza==null){
							System.err.println("ERRORE, categoria inesistente ");
							continue;
						}
						partenza.createRelationshipTo(g.getCategoria(link.split(">")[0]), DynamicRelationshipType.withName("SUBCATEGORYOF"));
					}
				}
				letti=0;
				idcats.clear();
				lnk.chiudi();
			}
		}
		g.termina();
		l.chiudi();
	}
}
