package progetto;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map.Entry;

import org.neo4j.graphdb.Direction;
import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;

import utilities.Lettore;
import utilities.Scrittore;
import wrapper.GraphWrapper;

public class RicercaAnelli {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		/*ricerca gli anelli nel grafo
		 * Utilizzo l'algoritmo di Tarjan
		 * 
		 */
		new RicercaAnelli();
		Lettore l=new Lettore("cicli_temp.txt");
		Scrittore s=new Scrittore("cicli.txt");
		String letta="";
		boolean prima=true;
		while((letta=l.leggi())!=null){
			if(letta.startsWith("--")){
				prima=true;
				continue;
			}
			if(prima)s.scrivi("-----------");
			prima=false;
			s.scrivi(letta);
		}
		s.chiudi();
		l.chiudi();
		

	}
	private GraphWrapper g;
	private int index;
	private ArrayList<Node> s;
	private Scrittore scr;
	public RicercaAnelli() throws IOException{
		this.scr=new Scrittore("cicli_temp.txt");
		this.g=new GraphWrapper("wp_semantico");
		this.index=0;
		this.s=new ArrayList<Node>();
		int analizzati=0;
		for(Node n:g.getAllNodes()){
			analizzati++;
			if(analizzati%1000==0)System.out.println("analizzati: "+analizzati);
			//salto gli articoli e le categorie vuote, sono inutili
			if(!n.hasProperty("idcat")) continue;
			if(g.getCategorieContenute(n).size()==0) continue;
			g.commit();
			if (!n.hasProperty("index")) tarjan(n);
		}
		scr.chiudi();
	}
	private void tarjan(Node n) throws IOException {
		System.out.println("analizzo "+n.getProperty("name"));
		n.setProperty("index", this.index);
		//dubbio: su wikipedia dice anche che va assegnato index e non MAX
		n.setProperty("lowlink",index);
		index++;
		s.add(n);
		g.commit();
		for(Relationship r:n.getRelationships(DynamicRelationshipType.withName("SUBCATEGORYOF"), Direction.INCOMING)){

			Node vp=r.getOtherNode(n);
			if(!vp.hasProperty("index")){
				tarjan(vp);
				if((Integer)vp.getProperty("lowlink",Integer.MAX_VALUE)<(Integer)n.getProperty("lowlink"))
					n.setProperty("lowlink", vp.getProperty("lowlink"));
			}
			else{
				if(s.contains(vp))
					if((Integer)vp.getProperty("index",Integer.MAX_VALUE)<(Integer)n.getProperty("lowlink"))
						n.setProperty("lowlink", vp.getProperty("index"));
			}
		}

		if(n.getProperty("lowlink").equals(n.getProperty("index"))){
			
			System.out.println("SSC:");
			scr.scrivi("-----------------------------");
			Node l;
			boolean singolo=true;
			while(!(l=s.remove(s.size()-1)).equals(n)){
				System.out.print(l.getProperty("name")+">");
				scr.scrivi(l.getProperty("name")+">");
				singolo=false;
			}
	if(!singolo)scr.scrivi(l.getProperty("name")+">");

			System.out.println();

		}
	}

}
