package progetto;

import java.io.IOException;

import org.neo4j.graphdb.Node;

import utilities.Lettore;
import utilities.User;
import wrapper.GraphWrapper;

public class RigeneraIndiciCategorieOrfane {

	//riassegna all'indice le categorie orfane che esistono ma non sono indicizzate
	//trovandole direttamente dall'elenco delle pagine non classificate
	public static void main(String[] args) throws IOException, InterruptedException {
		GraphWrapper g=new GraphWrapper("wp_semantico");
		Lettore l=new Lettore("pagine_inclassificabili.txt");
		String letta;
		while((letta=l.leggi())!=null){
			System.out.println(letta);
			Node p=g.getPagina(letta.split(">")[1]);
			if (p==null){
				System.err.println("ERRORE, la pagina non esiste: "+letta);
				User.chiediStringa("");
				continue;
			}
			for(Node cat:g.getCategorieAppartenenza(p)){
				if(cat.hasProperty("idpag")){
					//ERRORE: una pagina fa da categoria, segnalo e sistemo
					System.err.println("ERRORE: "+cat.getProperty("name")+" è una pagina ma contiene delle pagine con BELONGSTO");
					cat.setProperty("idcat", cat.getProperty("idpag"));
					cat.removeProperty("idpag");
					g.commit();
				}
				boolean trovata=false;
				//se è indicizzata, avanzo, altrimenti segnalo e indicizzo
				for(Node n:g.getNodes("name", cat.getProperty("name")))
					if(n.hasProperty("idcat")) trovata=true;
				if(trovata) continue;
				//non trovata, segnalo e indicizzo
				System.out.println("Non trovata: "+cat.getProperty("name"));
				g.indicizza(cat, "name", cat.getProperty("name"));
				g.commit();
			}
		}
		g.termina();
		l.chiudi();
	}

}
